1000	%title "skeleton_w/o_fms_xxx.bas"
	%ident					  "100.2"
	declare string constant	k_version	= "100.2"		,	&
				k_program	= "Skeleton_w/o_FMS"		! <--- remarks (column 81)
	!==================================================================================================
	! title  : "skeleton_wo_fms_xxx.bas" (skeleton with out FMS)
	! author : Neil Rieck
	! created: 2004.06.14
	! purpose: an introductory demo to show how to use VMS-BASIC with DEC-RMS (ISAM) but not DEC-FMS
	! build  : basic SKELETON_WO_FMS_100.BAS
	!          link  SKELETON_WO_FMS_100.obj
	! run    : run   SKELETON_WO_FMS_100
	! history:
	! ver who when     what
	! --- --- -------- --------------------------------------------------------------------------------
	! 100 NSR 20040614 1. original code
	!     NSR 20170612 2. a few tweaks after the move to Itanium
	!==================================================================================================
	option type=explicit							! no kid stuff
	set no prompt								! no automatic '?' on input
	!
	!	constants (usually prefixed with 'k_')
	!
	declare string constant	k_fs1$		= "Skeleton.dat"	,	! the ISAM data file	&
				k_provinces$	= "ON QC NB BC"			!
	!
	!	home brewed functions
	!
	external string function wcsm_dt_stamp
	%include "[.inc]device_controls.inc"					! VT + LA device control codes
	!
	!	variable declarations
	!
	declare string	command$,						!&
			choice$,						!&
			my_data$,						!&
			junk$,							!&
			temp$,							!&
		double	temp,							!&
		long	i%,							!&
			j%,							!&
			junk%,							!&
			temp%,							!&
			handler_error%,						!&
			rec_count%						!
	!
	!	This map defines the record layout of our file.
	!	Note that I've used a prefix of "d01_" which means that I will
	!		almost always open the assocated file on channel #1
	!
	map(skel) string	d01_whole_record	= 132,			!&
				d01_align		= 0			! to enforce align checks by the linker
	!
	!	this map overlays the previous map of the same name (so we want to ensure that it is the same size)
	!
	map(skel) string	d01_first_name		= 15	,		! 15	&
				d01_last_name		= 15	,		! 30	&
				d01_address		= 30	,		! 60	&
				d01_city		= 20	,		! 80	&
				d01_province		=  2	,		! 82	&
				d01_telephone		= 10	,		! 92	&
				d01_fill$		= 40	,		!132	need room to grow			&
				d01_align		= 0			!to enforce align checks by the linker
	!
	!========================================================================================================================
	!	main
	!========================================================================================================================
	main:
	print vt$clear + vt$home + k_program +"_"+ k_version			! print title
	print string$(len(k_program +"_"+ k_version), asc("="))			! underline it
	print "  1. display records"
	print "  2. add a record"
	print "  3. delete a record"
	print "  9. exit"
	print "Choice? (1-3,9) ";
	input command$
	command$ = edit$(command$,32+2)						! upcase, no white space
	command$ = left$(command$,1)						!
	select command$
	    case "1"
		gosub display_records
		goto main
	    case "2"
		gosub add_records
		goto main
	    case "3"
		gosub delete_records
		goto main
	    case "9"
		goto fini
	    case else
		print vt$error + "Oops, unsupported command";			! print error text on line #24
		sleep 1
		print vt$error + "";						! clear line #24
		goto main
	end select
	!
	!========================================================================================================================
	!	<<< display records >>>
	!========================================================================================================================
	display_records:
	print cr + lf + "Display Records" + cr + lf + 				&
			"==============="
	gosub open_data_file
	goto display_records_exit	if handler_error% <> 0
	print "Display by: N/ame, C/ity, P/rovince, T/elephone? (default=N/ame) ";
	input choice$
	choice$ = edit$(choice$,32+2)
	when error in
	    select choice$
		case "C"							! C/ity
		    find #1, key#3 nxeq " "					!
		case "P"							! P/rovince
		    find #1, key#4 nxeq " "					!
		case "T"							! T/elephone
		    find #1, key#2 nxeq " "					!
		case "N"							! N/ame
		    find #1, key#0 nxeq " "					!
		case else							! N/ame (default)
		    print "-i- defaulting to N/ame"
		    find #1, key#0 nxeq " "
	    end select
	    while 1
		get #1, regardless						! read w/o lock
		print "Name     : "+	edit$(d01_last_name,128)		!&
					+", "+					!&
					edit$(d01_first_name,128)		!
		print "Address  : "+	d01_address
		print "City     : "+	d01_city
		print "Province : "+	d01_province
		print "Telephone: "+	d01_telephone
		print
	    next
	use
	    handler_error% = err
	end when
	select handler_error%
	    case 0								! no error
	    case 11								! End Of File
	    case 134								! Record Not Found
	    case else
		print "-e-Error: "+ str$(handler_error%) + " while reading data"
		print "   Text : "+ ert$(handler_error%)
	end select
	print "hit <enter> to continue...";
	input junk$
	!
	display_records_exit:
	return
	!
	!========================================================================================================================
	!	<<< add records >>>
	!========================================================================================================================
	add_records:
	print cr + lf + "Add Records" + cr + lf + 				&
			"==========="
	gosub open_data_file
	goto add_records_exit	if handler_error% <> 0
	when error in
	    d01_whole_record = ""						! start with a clean slate (init the buffer)
	    !
	    input "Last Name  ? ";junk$
	    d01_last_name = edit$(junk$, 128+32+16+8)				! trailing, upcase, compress, leading
	    !
	    input "First Name ? ";junk$
	    d01_first_name = edit$(junk$, 128+32+16+8)				! trailing, upcase, compress, leading
	    !
	    input "Address    ? ";junk$
	    d01_address = edit$(junk$, 128+32+16+8)				! trailing, upcase, compress, leading
	    !
	    input "City       ? ";junk$
	    d01_city = edit$(junk$, 128+32+16+8)				! trailing, upcase, compress, leading
	    !
	    get_prov:
	    input "Province   ? ";junk$
	    junk$ = edit$(junk$, 128+32+16+8)					! trailing, upcase, compress, leading
	    if pos(k_provinces$, junk$, 1) = 0 then
		print "-e- not in the legal list of provinces ("+ k_provinces$ +")"
		goto get_prov
	    end if
	    d01_province = junk$
	    !
	    get_telephone:
	    input "Telephone  ? ";junk$
	    junk$ = edit$(junk$, 128+32+16+8)					! trailing, upcase, compress, leading
	    when error in
		temp = real(junk$,DOUBLE)
		junk% = 0
	    use
		junk% = err
	    end when
	    if junk% <> 0 then
		print "-e- non-numeric character detected in telephone field"
		goto get_telephone
	    end if
	    select len(junk$)
		case 0, 10
		case else
		    print "-e- telephone nust be BLANK or 10 characters"
		    goto get_telephone
	    end select
	    d01_telephone = junk$
	    !
	    !	now give the user a chance to either save or discard his input
	    !
	    print
	    print "Name     : "+	edit$(d01_last_name,128)		!&
					+", "+					!&
					edit$(d01_first_name,128)		!
	    print "Address  : "+	d01_address
	    print "City     : "+	d01_city
	    print "Province : "+	d01_province
	    print "Telephone: "+	d01_telephone
	    input "Save this record? (Y/N, default=N) ";choice$
	    select left$(edit$(choice$,32+2),1)
		case "Y"
		    print "-i-Saving record data"
		    put #1
		case else
		    print "-i-Discarding record data"
	    end select
	    !
	    handler_error% = 0							! signal all is well
	use
	    handler_error% = err
	end when
	select handler_error%
	    case 0								! no error
	    case 11								! End Of File
	    case 134								! Record Not Found
	    case else
		print "-e-Error: "+ str$(handler_error%) + " while writing data"
		print "   Text : "+ ert$(handler_error%)
	end select
	print "hit <enter> to continue...";
	input junk$
	add_records_exit:
	return
	!
	!========================================================================================================================
	!	<<< delete records >>>
	!========================================================================================================================
	delete_records:
	print cr + lf + "Delete Records" + cr + lf + 				&
			"=============="
	gosub open_data_file
	goto delete_records_exit	if handler_error% <> 0
	print "Lookup by: N/ame(last), C/ity, P/rovince, T/elephone? (default=exit) ";
	input choice$
	choice$ = edit$(choice$,32+2)
	goto delete_records_exit	if pos("NCPT",choice$,1) = 0		! command not in list so exit
	!
	input "Full or Partial search data? ";my_data$
	my_data$ = edit$(my_data$,128+32+16+8)					! trailing, upcase, compress, collapse
	my_data$ = " " if my_data$ = ""						! don't allow a null string
	when error in
	    select choice$
		case "C"							! C/ity
		    find #1, key#3 nxeq my_data$				!
		case "P"							! P/rovince
		    find #1, key#4 nxeq my_data$				!
		case "T"							! T/elephone
		    find #1, key#2 nxeq my_data$				!
		case "N"							! N/ame
		    find #1, key#0 nxeq my_data$				!
		case else							! default (shouldn't get this far)
		    print "-e- oops, programmer error." + bel			!
		    goto delete_records_exit 
	    end select
	    while 1
		get #1								! read w/lock
		!
		!	note: since I used the phrase "nxeq" in the previous FIND statement,
		!	it is possible that RMS may overshoot the record that I thought was present but was actually missing.
		!	So make sure the record data matches our search data.
		!
		if my_data$ <> " " then						! if not using a blank (but not null) key
		    select choice$
			case "C"						! C/ity
			    cause error 155 if my_data$ <> left$(d01_city,len(my_data$))
			case "P"						! P/rovince
			    cause error 155 if my_data$ <> left$(d01_province,len(my_data$))
			case "T"						! T/elephone
			    cause error 155 if my_data$ <> left$(d01_telephone,len(my_data$))
			case "N"						! N/ame
			    cause error 155 if my_data$ <> left$(d01_last_name,len(my_data$))
			case else						! default (shouldn't get this far)
			    print "-e- oops, programmer error." + bel		!
			    goto delete_records_exit 
		    end select
		end if
		!
		!	at this point, we're sitting on the record with a lock in place and ready to DELETE
		!
		print "Name     : "+	edit$(d01_last_name,128)		!&
					+", "+					!&
					edit$(d01_first_name,128)		!
		print "Address  : "+	d01_address
		print "City     : "+	d01_city
		print "Province : "+	d01_province
		print "Telephone: "+	d01_telephone
		print
		input "O.K. to delete this record? (Y/N/S, default=N) ";junk$
		select left$(edit$(junk$,32+2),1)
		    case "Y"							!
			print "-i-Deleting record data"
			delete #1
		    case "S"
			unlock #1						! don't leave a lock on this record
			goto delete_records_exit
		    case else
			print "-i-skipping delete"
		end select
		print "-i- reading next record (in selected key)"
	    next
	use
	    handler_error% = err
	end when
	select handler_error%
	    case 0								! no error
	    case else
		print "-e-Error: "+ str$(handler_error%) + " while reading data"
		print "   Text : "+ ert$(handler_error%)
	end select
	print "hit <enter> to continue...";
	input junk$
	!
	delete_records_exit:
	return
	!
	!========================================================================================================================
	!	<<< open data file >>>
	!========================================================================================================================
	open_data_file:
	when error in
	    open k_fs1$ as #1							&
		,organization indexed						&
		,map skel							&
		,primary key (d01_last_name, d01_first_name)			&
		,alternate key d01_last_name	duplicates changes		&
		,alternate key d01_telephone	duplicates changes		&
		,alternate key d01_city		duplicates changes		&
		,alternate key d01_province	duplicates changes		!
	    handler_error% = 0							! signal all is well
	use
	    handler_error% = err
	end when
	select handler_error%
	    case 0
	    case else
		print "-e-Error: "+ str$(handler_error%) + " while opening data file"
		print "   Text : "+ ert$(handler_error%)
		print "hit <enter> to continue...";
	end select
	return
	!
	!========================================================================================================================
	!	Adios
	!========================================================================================================================
	fini:
	print "Adios..."	
32000	end									! our program ends here
	!========================================================================================================================
	!	external functions and sub-programs are pulled-in here (after program end)
	!========================================================================================================================
	!
32100	function string Wcsm_DT_Stamp
	!===================================================================================================================
	! Title  : Wcsm_DT_Stamp_100?.inc
	! Author : Neil S. Rieck
	! Purpose: an external function to return a y2k compliant system time in the form ccyymmddhhmmss (14 chars)
	! Notes  : all our programs call this function so optimizations here will speed up the whole system
	! History:
	! 100  NSR 911229 1. original work
	!===================================================================================================================
	option   type=explicit							! cuz tricks are for kids...
	!
	%include "starlet" %from %library "sys$library:basic$starlet"           !
	!
	declare  long sys_status
	!
	!	this map is required for the call to sys$asctim (format: 19-JUN-1998 23:59:59.1)
	!
	map (WcsmDTStamp0)	string	Sys_buf_22	= 22
	map (WcsmDTStamp0)	string	Sys_day		=  2,	!	&
					Sys_dash1	=  1,	!-	&
					Sys_month	=  3,	!	&
					Sys_dash2	=  1,	!-	&
					Sys_year	=  4,	!	&
					Sys_space	=  1,	!	&
					Sys_Hour	=  2,	!	&
					Sys_colon1	=  1,	!:	&
					Sys_Minute	=  2,	!	&
					Sys_colon2	=  1,	!:	&
					Sys_Second	=  2,	!	&
					Sys_period	=  1,	!.	&
					Sys_Tenth	=  1	!
	!
	!	map for Wcsm date (output)
	!
	map (WcsmDTStamp1)	string	Wcsm_buf_14	= 14	!
	map (WcsmDTStamp1)	string	Wcsm_year	=  4,	!	&
					Wcsm_month	=  2,	!	&
					Wcsm_day	=  2,	!	&
					Wcsm_Hour	=  2,	!	&
					Wcsm_Minute	=  2,	!	&
					Wcsm_Second	=  2
	map (WcsmDTStamp1)	string	Wcsm_year	=  4,	!	&
					Wcsm_month_tens	=  1,	!	&
					Wcsm_month_ones	=  1,	!	&
					Wcsm_day_tens	=  1,	!	&
					Wcsm_day_ones	=  1,	!	&
					Wcsm_Hour	=  2,	!	&
					Wcsm_Minute	=  2,	!	&
					Wcsm_Second	=  2
	!
	!	string constants
	!					  00000000011111111112222222222333333333
	!					  12345678901234567890123456789012345678
	declare string constant k_month_names$ = "XXJANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC"
	!					  ||
	!					  ++-- so I don't have to provide an offset in pos()
	declare string constant my_space = '32'C
	!
	!	<<< function 'code' starts here >>>
	!
	when error in
		!
		sys_status = sys$asctim(,Sys_buf_22,,)				! get ASCII time into sys_buf_22
!~~~		if (sys_status and 7%) <> 1% then cause error 11		x  not required - call will never fail
		!
		!	transfer data from one map to the other
		!	
		Wcsm_year	= Sys_year					!
!~~~	rset	Wcsm_month	= str$( pos(k_month_names$,Sys_Month,1%) / 3%)	x					bf_100f
		Wcsm_day	= Sys_day					!
		Wcsm_hour	= Sys_hour					!
		Wcsm_minute	= Sys_minute					!
		Wcsm_second	= Sys_second					!
		!
		declare long temp%						!					bf_100f
		temp% = pos(k_month_names$,Sys_Month,1%) / 3%			! compute month number			bf_100f
		if temp% < 10% then						! if less than 10...			bf_100f
		    Wcsm_month_ones	= str$(temp%)				! ...then this goes into ONES		bf_100f
		    Wcsm_month_tens	= "0"					! ...and this goes into TENS		bf_100f
		else								! else >= 10				bf_100f
		    Wcsm_month		= str$(temp%)				!					bf_100f
		end if
		!
		!	make sure there are no spaces in the TENS area of our mapped variables (pad with '0' if necessary)
		!
!~~~		Wcsm_month_tens = "0"	if Wcsm_month_tens	= my_space	x disabled - see above code		bf_100f
		Wcsm_day_tens	= "0"	if Wcsm_day_tens	= my_space	!
		!
		!	now pass result back to caller
		!
		Wcsm_DT_Stamp = Wcsm_Buf_14					! this is it folks
	use
		Wcsm_DT_Stamp = ""						! error so return blank
	end when
	!
	END Function
	!=================================================================================================================

